<ui:composition xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:rich="http://richfaces.org/rich"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:g="http://www.ihe.net/gazelle"
                xmlns="http://www.w3.org/1999/xhtml">
    #{dataTableStateHolder.setDescendingOn('id')}
    <h:form>
        <rich:dataTable id="certificateTable" value="#{certificatesListBean.dataModel}" var="certificate"
                        rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                        render="certDS">
            <g:column sortBy="#{'id'}" sortOrder="#{dataTableStateHolder.sortOrders['id']}">
                <ui:define name="header">
                    <h:outputText
                            value="#{net.ihe.gazelle.atna.Certificate} #{messages['net.ihe.gazelle.proxy.Id']}"/>
                </ui:define>
                <h:outputText value="#{certificate.id}"/>
            </g:column>
            <g:column sortBy="#{'subject'}" sortOrder="#{dataTableStateHolder.sortOrders['subject']}"
                      filterBy="#{'subject'}" styleClass="gzl-break-long-word">
                <ui:define name="header">
                    <h:outputText value="#{messages['net.ihe.gazelle.atna.Subject']}"/>
                </ui:define>
                <h:commandLink action="#{certificateBean.redirectToCert(certificate.id)}"
                               value="#{certificate.subject}" target="_blank"/>
            </g:column>
            <g:column sortBy="#{'request.requesterUsername'}"
                      sortOrder="#{dataTableStateHolder.sortOrders['request.requesterusername']}"
                      filterBy="#{'request.requesterUsername'}">
                <ui:define name="header">
                    <h:outputText value="#{messages['net.ihe.gazelle.atna.Requester']}"/>
                </ui:define>
                <h:outputText value="#{certificateBean.getUserName(certificate.request.requesterUsernameWithKey)}"
                              rendered="#{not empty certificate.request}"/>
                <h:outputText value="#{messages['net.ihe.gazelle.atna.None']}"
                              rendered="#{empty certificate.request or empty certificate.request.requesterUsername}"/>
            </g:column>
            <g:column sortBy="#{'certificateAuthority.subject'}"
                      sortOrder="#{dataTableStateHolder.sortOrders['certificateauthority.subject']}"
                      filterBy="#{'certificateAuthority.subject'}">
                <ui:define name="header">
                    <h:outputText value="#{messages['net.ihe.gazelle.atna.CASubject']}"/>
                </ui:define>
                <h:commandLink value="#{certificate.certificateAuthority.subject}"
                               rendered="#{certificate.certificateAuthority != null}"
                               action="#{certificateBean.redirectToCert(certificate.certificateAuthority.id)}"
                               target="_blank"/>
                <h:outputText value="#{messages['net.ihe.gazelle.atna.None']}"
                              rendered="#{certificate.certificateAuthority == null}"/>
            </g:column>
            <g:column sortBy="#{'request.certificateExtension'}"
                      sortOrder="#{dataTableStateHolder.sortOrders['request.certificateExtension']}">
                <ui:define name="header">
                    <h:outputText value="#{messages['net.ihe.gazelle.proxy.Type']}"/>
                </ui:define>
                <h:outputText value="#{certificate.request.certificateExtension.getFriendlyName()}"
                              rendered="#{certificate.request != null}"/>
                <h:outputText value="#{messages['net.ihe.gazelle.atna.Unknown']}"
                              rendered="#{certificate.request == null}"/>
            </g:column>
            <rich:column styleClass="text-right">
                <f:facet name="header">#{messages['net.ihe.gazelle.atna.Actions']}</f:facet>
                <div class="gzl-never-wrap">
                    <h:commandLink action="#{certificateBean.redirectToCert(certificate.id)}"
                                   title="#{messages['net.ihe.gazelle.atna.ViewCertificate']}"
                                   styleClass="action text-normal">
                        <s:span styleClass="fa fa-search"></s:span>
                    </h:commandLink>
                    <div class="btn-group" style="vertical-align: baseline;">
                        <a href="#" class="dropdown-toggle action text-normal" data-toggle="dropdown" role="button"
                           aria-expanded="false" title="Download certificate">
                            <span class="fa fa-download"></span>
                        </a>
                        <ul class="dropdown-menu dropdown-menu-right text-right">
                            <li>
                                <h:commandLink action="#{certificatesListBean.downloadCertPEM(certificate.id)}"
                                               title="#{messages['net.ihe.gazelle.atna.PEMFilesCanBeRenamedWithcrtExtension']}"
                                               value="#{messages['net.ihe.gazelle.atna.DownloadInPEMFormat']}"/>
                            </li>
                            <li>
                                <h:commandLink action="#{certificatesListBean.downloadCertDER(certificate.id)}"
                                               value="#{messages['net.ihe.gazelle.atna.DownloadInDERFormat']}"/>
                            </li>
                        </ul>
                    </div>
                    <a4j:commandLink action="#{certificatesListBean.setCertificateToDelete(certificate.id)}"
                                     oncomplete="jq162('#deleteModal').modal('show');"
                                     title="#{messages['net.ihe.gazelle.atna.DeleteCertificate']}"
                                     rendered="#{s:hasRole('admin_role')}" render="deleteForm"
                                     styleClass="action triggerDeleteModal text-danger">
                        <s:span styleClass="fa fa-trash-o"></s:span>
                    </a4j:commandLink>
                </div>
            </rich:column>
            <f:facet name="footer">
                <ui:include src="/util/datatableFooter.xhtml">
                    <ui:param name="dataScrollerId" value="certDS"/>
                    <ui:param name="dataTableId" value="certificateTable"/>
                </ui:include>
            </f:facet>
        </rich:dataTable>

    </h:form>
    <h:panelGroup rendered="#{s:hasRole('admin_role')}">
        <h:form id="deleteForm">
            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="deleteModal"/>
                <ui:define name="popup_title"><span class="fa fa-exclamation-triangle"></span>#{messages['net.ihe.gazelle.questionnaire.Warning']}
                </ui:define>
                <p>#{messages['net.ihe.gazelle.atna.YouAreAboutToDeleteTheCertificateItCanNotBeUndon']}</p>
                <ui:define name="popup_footer">
                    <button type="button" class="gzl-btn" data-dismiss="modal">
                        #{messages['net.ihe.gazelle.atna.Cancel']}
                    </button>
                    <a4j:commandButton actionListener="#{certificatesListBean.deleteCertificateReal()}"
                                       oncomplete="jq162('#deleteModal').modal('hide')"
                                       value="#{messages['net.ihe.gazelle.atna.Delete']}"
                                       render="certificateTable"
                                       styleClass="gzl-btn-red">
                    </a4j:commandButton>
                </ui:define>
            </ui:decorate>
        </h:form>
    </h:panelGroup>
</ui:composition>
